<template lang="html">
  <div class="signup-dialog">
    <div class="content">
      <!-- Select basic info -->
      <div v-show="currentForm === '1'" class="basic-prompt">
        <form class="form" v-on:submit="submitForm1($event)">
          <!-- Full Name -->
          <label for="fullname">{{ label.FULLNAME }}</label>
          <input v-model.trim="form1.fullname"
            type="text"
            id="fullname"
            class="fullname"
            name="name">
          <div v-if="form1.isSubmitted && $v.form1.fullname.$invalid" class="error">
            <span v-if="!$v.form1.fullname.required">Your Full Name is required.</span>
            <span v-else-if="!$v.form1.fullname.maxLength">Name must be shorter than 20 characters.</span>
          </div>
          <!-- Email -->
          <label for="email">{{ label.EMAIL }}</label>
          <input v-model.trim="form1.email"
            type="text"
            id="email"
            class="email"
            name="email"
            v-on:keyup="onKeyUpEmail($event.target.value)">
            <div v-if="form1.isSubmitted && $v.form1.email.$invalid && form1.isEmailChecked" class="error">
              <span v-if="!$v.form1.email.required">Your Email is required.</span>
              <span v-else-if="!$v.form1.email.email">Email must be valid.</span>
              <span v-else-if="!$v.form1.email.isUnique">This email is unavailable.</span>
            </div>
          <!-- Password -->
          <label for="password">{{ label.PASSWORD }}</label>
          <input v-model.trim="form1.password"
            type="password"
            id="password"
            class="password">
          <div v-if="form1.isSubmitted && $v.form1.password.$invalid" class="error">
            <span v-if="!$v.form1.password.required">Password is required.</span>
            <span v-else-if="!$v.form1.password.passwordHasMinLength">Password must contain at least {{ passwordMinLength }} characters</span>
            <span v-else-if="!$v.form1.password.passwordContainsLetter">Password must contain at least 1 letter</span>
            <span v-else-if="!$v.form1.password.passwordContainsNumber">Password must contain at least 1 number</span>
            <span v-else-if="!$v.form1.password.passwordContainsUppercase">Password must contain at least 1 uppercase character</span>
            <span v-else-if="!$v.form1.password.passwordContainsSpecial">Password must contain at least 1 special character</span>
          </div>
          <input type="submit" class="signupBtn" :value="label.SIGNUP">
        </form>
        <div v-show="!showSpinner1" class="signin-prompt-container">
          <span>{{ label.OLD_USER }}</span>
          <button v-on:click="showDialog('signin')"
            class="signinBtn linkBtn">{{ label.SIGNIN }}</button>
        </div>
        <div v-show="showSpinner1" class="spinner">
          <ep-spinner class="spinner-icon"></ep-spinner>
        </div>
      </div>
      <!-- Select username -->
      <div v-show="currentForm === '2'" class="username-prompt">
        <button class="backBtn linkBtn" v-on:click="navigateToForm('1')">{{ label.BACK }}</button>
        <h2>{{ label.CHOOSE_USERNAME }}</h2>
        <p>{{ label.CHOOSE_USERNAME_DETAIL }}</p>
        <form class="form" v-on:submit="submitForm2($event)">
          <label for="username">enoplay.com/{{ form2.username.toLowerCase() }}</label>
          <input v-model.trim="form2.username"
            type="text"
            id="username"
            ref="username"
            :placeholder="label.USERNAME"
            class="username"
            v-on:keyup="onKeyUpUsername($event.target.value)">
          <div v-if="form2.isSubmitted && $v.form2.username.$invalid && form2.isUsernameChecked" class="error">
            <span v-if="!$v.form2.username.required">Username is required.</span>
            <span v-else-if="!$v.form2.username.maxLength">Username must be shorter than 15 characters.</span>
            <span v-else-if="!$v.form2.username.nonSpecial">No special characters.</span>
            <span v-else-if="!$v.form2.username.isUnique">This Username taken.</span>
          </div>
          <div v-else-if="$v.form2.username.$pending || !$v.form2.username.$invalid"  class="success">
            <span>This Username is available.</span>
          </div>
          <div class="g-recaptcha" :data-sitekey="recaptchSiteKey"></div>
          <input type="submit" class="readyBtn" :value="label.READY">
        </form>
        <div v-if="registerAttemptStatus" class="signUpError error">
          <span>Error: {{ registerAttemptStatus }}</span>
        </div>
        <div v-show="showSpinner2" class="spinner">
          <ep-spinner class="spinner-icon"></ep-spinner>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex'
import { required, email, maxLength } from 'vuelidate/lib/validators'
import { passwordMinLength,
  passwordHasMinLength,
  passwordContainsLetter,
  passwordContainsNumber,
  passwordContainsUppercase,
  passwordContainsSpecial
} from '~/utils/formValidator'

import Spinner from '../Spinner'

export default {
  name: 'ep-signup-dialog',
  components: {
    'ep-spinner': Spinner
  },
  data () {
    return {
      currentForm: '1',
      registerAttemptStatus: '',
      showSpinner1: false,
      showSpinner2: false,
      recaptchaID: '',
      recaptchSiteKey: process.env.RECAPTCHA_SITE_KEY,
      form1: {
        fullname: '',
        email: '',
        password: '',
        isEmailUnique: false,
        isEmailChecked: false,
        isSubmitted: false
      },
      form2: {
        username: '',
        isUsernameUnique: false,
        isUsernameChecked: false,
        isSubmitted: false
      },
      label: {
        FULLNAME: 'Full name',
        EMAIL: 'Email',
        USERNAME: 'Username',
        PASSWORD: 'Password',
        SIGNUP: 'Sign up',
        SIGNIN: 'Sign in',
        READY: 'Ready!',
        BACK: 'Back',
        CHOOSE_USERNAME: 'Choose a Username',
        CHOOSE_USERNAME_DETAIL: 'Don\'t worry, you can always change it later.',
        OLD_USER: 'Have an account?'
      },
      passwordMinLength: passwordMinLength,
      typingTimers: {},
      doneTypingInterval: 2000, // 2 seconds
      TIMER_USERNAME: 'username',
      TIMER_EMAIL: 'email'
    }
  },
  validations: {
    form1: {
      fullname: {
        required,
        maxLength: maxLength(20)
      },
      email: {
        required,
        email,
        isUnique (value) {
          if (value === '') return true
          return this.form1.isEmailUnique && this.form1.isEmailChecked
        }
      },
      password: {
        required,
        passwordHasMinLength,
        passwordContainsLetter,
        passwordContainsNumber,
        passwordContainsUppercase,
        passwordContainsSpecial
      }
    },
    form2: {
      username: {
        required,
        maxLength: maxLength(15),
        nonSpecial (value) {
          return /^[a-zA-Z0-9_]*$/.test(value)
        },
        isUnique (value) {
          if (value === '') return true
          return this.form2.isUsernameUnique && this.form2.isUsernameChecked
        }
      }
    },
    validationGroup: ['form1.fullname', 'form1.email', 'form1.password', 'form2.username']
  },
  computed: {
    ...mapState('app', [
      'dialogTypes'
    ])
  },
  mounted () {
    this.renderRecaptcha()
  },
  methods: {
    ...mapActions('app', [
      'selectDialog'
    ]),
    onKeyUpEmail (email) {
      if (this.typingTimers[this.TIMER_EMAIL]) {
        clearTimeout(this.typingTimers[this.TIMER_EMAIL])
      }

      this.typingTimers[this.TIMER_EMAIL] = setTimeout(() => {
        this.checkEmailAvailability(email)
      }, this.doneTypingInterval)
    },
    onKeyUpUsername (username) {
      if (this.typingTimers[this.TIMER_USERNAME]) {
        clearTimeout(this.typingTimers[this.TIMER_USERNAME])
      }

      this.typingTimers[this.TIMER_USERNAME] = setTimeout(() => {
        this.checkUsernameAvailability(username)
      }, this.doneTypingInterval)
    },
    checkEmailAvailability (email) {
      this.form1.isEmailUnique = false
      this.form1.isEmailChecked = false

      if (!email) {
        this.form1.isEmailChecked = true
        return Promise.resolve()
      }

      return this.$store.dispatch('checkEmailAvailability', email)
      .then(isUniqueResponse => {
        this.form1.isEmailUnique = isUniqueResponse
        this.form1.isEmailChecked = true
      })
      .catch(() => {
        this.form1.isEmailUnique = false
        this.form1.isEmailChecked = true
      })
    },
    checkUsernameAvailability (username) {
      this.form2.isUsernameUnique = false
      this.form2.isUsernameChecked = false

      if (!username) {
        this.form2.isUsernameChecked = true
        return Promise.resolve()
      }

      return this.$store.dispatch('checkUsernameAvailability', username)
      .then(isUniqueResponse => {
        this.form2.isUsernameUnique = isUniqueResponse
        this.form2.isUsernameChecked = true
      })
      .catch(() => {
        this.form2.isUsernameUnique = false
        this.form2.isUsernameChecked = true
      })
    },
    submitForm1 (event) {
      event.preventDefault()

      this.showSpinner1 = true
      this.form1.isSubmitted = true

      // Clear setTimeout call
      if (this.typingTimers[this.TIMER_EMAIL]) {
        clearTimeout(this.typingTimers[this.TIMER_EMAIL])
      }

      this.checkEmailAvailability(this.form1.email)
      .then(() => {
        this.showSpinner1 = false

        if (this.$v.form1.$invalid) {
          return
        }

        // Next form
        this.navigateToForm('2')
      })
      .catch(() => {
        this.showSpinner1 = false
      })
    },
    submitForm2 (event) {
      event.preventDefault()

      this.showSpinner2 = true
      this.form2.isSubmitted = true

      // Register
      this.register()
    },
    register () {
      // Clear timeout calls
      if (this.typingTimers[this.TIMER_EMAIL]) {
        clearTimeout(this.typingTimers[this.TIMER_EMAIL])
      }

      if (this.typingTimers[this.TIMER_USERNAME]) {
        clearTimeout(this.typingTimers[this.TIMER_USERNAME])
      }

      // Retrieve recaptcha response
      let recaptchaResponse = this.getRecaptchaResponse()

      this.checkEmailAvailability(this.form1.email)
      .then(() => {
        return this.checkUsernameAvailability(this.form2.username)
      })
      .then(() => {
        if (this.$v.validationGroup.$invalid) {
          return Promise.reject('Ensure form fields are valid')
        }

        if (!recaptchaResponse) {
          return Promise.reject('Verify recaptcha')
        }

        return this.$store.dispatch('register', {
          email: this.form1.email,
          username: this.form2.username,
          alias: this.form1.fullname,
          password: this.form1.password,
          recaptcha: recaptchaResponse
        }).then(() => {
          // Registration complete!
          this.showSpinner2 = false
        })
      })
      .catch(err => {
        this.showSpinner2 = false
        this.registerAttemptStatus = err
      })
    },
    renderRecaptcha () {
      if (window.grecaptcha) {
        this.recaptchaID = window.grecaptcha.render(document.querySelectorAll('.g-recaptcha')[0], {
          sitekey: process.env.RECAPTCHA_SITE_KEY
        })
      }
    },
    getRecaptchaResponse () {
      return window.grecaptcha.getResponse(this.recaptchaID)
    },
    navigateToForm (num) {
      this.currentForm = num

      switch (num) {
        case '2':
          setTimeout(() => {
            this.$refs.username.focus()
          }, 100)
          break
        default:
          // No default
      }
    },
    showDialog (option) {
      this.selectDialog({
        dialog: this.dialogTypes[option]
      })
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/theme';
@import '~assets/styles/input';

.signup-dialog {
  position: relative;
  display: block;
  background: #FFFFFF;
  width: $dialog-width;
  overflow: hidden;
}

.content {
  position: relative;
  padding: 40px 20px;
  margin: auto;
  text-align: center;
}

.form {
  text-align: left;
}

.g-recaptcha {
  transform: scale(0.79);
  transform-origin: 0 0;
}

.signinBtn {
  margin-top: 16px;
}

.signup-prompt-container {
  * {
    display: inline-block;
  }
}

.backBtn {
  margin-bottom: 20px;
}

.username-prompt {
  text-align: left;
}

.success {
  margin-bottom: 20px;
  color: $form-primary-color;
}

.error {
  margin-bottom: 20px;
  color: #cc0000;

  &.signUpError {
    margin-top: 12px;
    margin-bottom: 0;
  }
}
</style>
